Package: fUnitRoots
Title: Rmetrics - Modelling Trends and Unit Roots
Version: 4052.82
Authors@R: c(person("Diethelm", "Wuertz", role="aut", comment = "original code")
	   , person("Tobias", "Setz", role = c("aut"), email = "tobias.setz@live.com")
	   , person("Yohan", "Chalabi", role = "aut")
	   , person(given = c("Georgi", "N."), family = "Boshnakov", 
                    role = c("cre"), email = "georgi.boshnakov@manchester.ac.uk",
		    comment = c(ORCID = "0000-0003-2839-346X")) )
Description: Provides four addons for analyzing trends and
    unit roots in financial time series: (i) functions for the density
    and probability of the augmented Dickey-Fuller Test, (ii) functions 
    for the density and probability of MacKinnon's unit root test 
    statistics, (iii) reimplementations for the ADF and MacKinnon
    Test, and (iv) an 'urca' Unit Root Test Interface for Pfaff's
    unit root test suite.
Depends: R (>= 2.15.1)
Imports: timeSeries, fBasics, urca, graphics, methods, stats, utils
Suggests: RUnit, interp
License: GPL (>= 2)
URL: https://geobosh.github.io/fUnitRootsDoc/ (doc),
        https://CRAN.R-project.org/package=fUnitRoots,
        https://www.rmetrics.org
BugReports: https://r-forge.r-project.org/tracker/?atid=633&group_id=156&func=browse
NeedsCompilation: yes
Packaged: 2025-12-19 11:27:34 UTC; georgi
Author: Diethelm Wuertz [aut] (original code),
  Tobias Setz [aut],
  Yohan Chalabi [aut],
  Georgi N. Boshnakov [cre] (ORCID:
    <https://orcid.org/0000-0003-2839-346X>)
Maintainer: Georgi N. Boshnakov <georgi.boshnakov@manchester.ac.uk>
Repository: CRAN
Date/Publication: 2025-12-19 13:50:14 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-27 16:59:38 UTC; unix
Archs: fUnitRoots.so.dSYM

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received A copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


# fEcofin-DickeyFullerPValues.R
################################################################################
# FUNCTION:            AUGMENTED DICKEY FULLER DATA TABLES:
# adfTable              Finite sample p values for the Dickey-Fuller test
# .adfPlot              Plots sample p values for the Dickey-Fuller test
# padf                  Returns probabilities  for the ADF Test given quantiles
# qadf                  Returns quantiles for the ADF Test given probabilities
################################################################################


################################################################################
# FUNCTION:            AUGMENTED DICKEY FULLER DATA TABLES:
# adfTable              Finite sample p values for the Dickey-Fuller test
# .adfPlot              Plots sample p values for the Dickey-Fuller test
# padf                  Returns probabilities  for the ADF Test given quantiles
# qadf                  Returns quantiles for the ADF Test given probabilities


adfTable =
function(trend = c("nc", "c", "ct"), statistic = c("t", "n"), includeInf = TRUE)
{   # A function implemented by Diethelm Wuertz

    # Description:     
    #   Tables critical values for augmented Dickey-Fuller test.
    
    # Note: 
    #   x=-3:0; y=0:3; z=outer(x,y,"*"); rownames(z)=x; colnames(z)=y; z
    
    # Examples:
    #   adfTable()

    # FUNCTION:
      
    # Match Arguments:
    type = trend = match.arg(trend)
    statistic = match.arg(statistic)
    
    # Tables:
    if (statistic == "t") {
        # Hamilton Table B.6 - OLS t-Statistic
        if (type == "nc") {
            table = cbind(
                c(-2.66, -2.26, -1.95, -1.60, +0.92, +1.33, +1.70, +2.16),
                c(-2.62, -2.25, -1.95, -1.61, +0.91, +1.31, +1.66, +2.08),
                c(-2.60, -2.24, -1.95, -1.61, +0.90, +1.29, +1.64, +2.03),
                c(-2.58, -2.23, -1.95, -1.62, +0.89, +1.29, +1.63, +2.01),
                c(-2.58, -2.23, -1.95, -1.62, +0.89, +1.28, +1.62, +2.00),
                c(-2.58, -2.23, -1.95, -1.62, +0.89, +1.28, +1.62, +2.00))
        } else if (type == "c") {
            table = cbind(
                c(-3.75, -3.33, -3.00, -2.63, -0.37, +0.00, +0.34, +0.72),
                c(-3.58, -3.22, -2.93, -2.60, -0.40, -0.03, +0.29, +0.66),
                c(-3.51, -3.17, -2.89, -2.58, -0.42, -0.05, +0.26, +0.63),
                c(-3.46, -3.14, -2.88, -2.57, -0.42, -0.06, +0.24, +0.62),
                c(-3.44, -3.13, -2.87, -2.57, -0.43, -0.07, +0.24, +0.61),
                c(-3.43, -3.12, -2.86, -2.57, -0.44, -0.07, +0.23, +0.60))
        } else if (type == "ct") {
            table = cbind(
                c(-4.38, -3.95, -3.60, -3.24, -1.14, -0.80, -0.50, -0.15),
                c(-4.15, -3.80, -3.50, -3.18, -1.19, -0.87, -0.58, -0.24),
                c(-4.04, -3.73, -3.45, -3.15, -1.22, -0.90, -0.62, -0.28),
                c(-3.99, -3.69, -3.43, -3.13, -1.23, -0.92, -0.64, -0.31),
                c(-3.98, -3.68, -3.42, -3.13, -1.24, -0.93, -0.65, -0.32),
                c(-3.96, -3.66, -3.41, -3.12, -1.25, -0.94, -0.66, -0.33))      
        } else {
            stop("Invalid type specified")
        }
    } else if (statistic == "z" || statistic == "n") {
        # Hamilton Table B.5 - Based on OLS Autoregressive Coefficient
        if (type == "nc") {
            table = cbind(
                c(-11.9,  -9.3,  -7.3,  -5.3, +1.01, +1.40, +1.79, +2.28),
                c(-12.9,  -9.9,  -7.7,  -5.5, +0.97, +1.35, +1.70, +2.16),
                c(-13.3, -10.2,  -7.9,  -5.6, +0.95, +1.31, +1.65, +2.09),
                c(-13.6, -10.3,  -8.0,  -5.7, +0.93, +1.28, +1.62, +2.04),
                c(-13.7, -10.4,  -8.0,  -5.7, +0.93, +1.28, +1.61, +2.04),
                c(-13.8, -10.5,  -8.1,  -5.7, +0.93, +1.28, +1.60, +2.03))
        } else if (type == "c") {
            table = cbind(
                c(-17.2, -14.6, -12.5, -10.2, -0.76, +0.01, +0.65, +1.40),
                c(-18.9, -15.7, -13.3, -10.7, -0.81, -0.07, +0.53, +1.22),
                c(-19.8, -16.3, -13.7, -11.0, -0.83, -0.10, +0.47, +1.14),
                c(-20.3, -16.6, -14.0, -11.2, -0.84, -0.12, +0.43, +1.09),
                c(-20.5, -16.8, -14.0, -11.2, -0.84, -0.13, +0.42, +1.06),
                c(-20.7, -16.9, -14.1, -11.3, -0.85, -0.13, +0.41, +1.04))
        } else if (type == "ct") {
            table = cbind(
                c(-22.5, -19.9, -17.9, -15.6, -3.66, -2.51, -1.53, -0.43),
                c(-25.7, -22.4, -19.8, -16.8, -3.71, -2.60, -1.66, -0.65),
                c(-27.4, -23.6, -20.7, -17.5, -3.74, -2.62, -1.73, -0.75),
                c(-28.4, -24.4, -21.3, -18.0, -3.75, -2.64, -1.78, -0.82),
                c(-28.9, -24.8, -21.5, -18.1, -3.76, -2.65, -1.78, -0.84),
                c(-29.5, -25.1, -21.8, -18.3, -3.77, -2.66, -1.79, -0.87))      
        } else {
            stop("Invalid type specified")
        }
    } else {
        stop("Invalid statistic specified")
    }
            
    # Transpose:
    Table = t(table)
    colnames(Table) = c("0.010", "0.025", "0.050", "0.100", "0.900", 
        "0.950", "0.975", "0.990")
    rownames(Table) = c(" 25", " 50", "100", "250", "500", "Inf")
    ans = list(
        x = as.numeric(rownames(Table)),
        y = as.numeric(colnames(Table)),
        z = Table)
    class(ans) = "gridData"
    
    # Exclude Inf:
    if (!includeInf) {
        nX = length(ans$x)
        ans$x = ans$x[-nX]
        ans$z = ans$z[-nX, ]
    }
    
    # Add Control:
    attr(ans, "control") <-
        c(table = "adf", trend = trend, statistic = statistic)
        
    # Return Value:
    ans
} 


# ------------------------------------------------------------------------------


.adfPlot =
function(trend = c("nc", "c", "ct"), statistic = c("t", "n"))
{   # A function implemented by Diethelm Wuertz

    # Match Arguments:
    trend = match.arg(trend)
    statistic = match.arg(statistic)
    
    # Load Table:
    Y = adfTable(trend, statistic, includeInf = FALSE)
    X = cbind(expand.grid(x = Y$x, y = Y$y), z = as.vector(Y$z))
    x = X[, 1] # N
    y = X[, 3] # q-Stat
    z = X[, 2] # p-Value
    
    # Interpolate:
    gridPoints = 51
    ans = linearInterp(x, y, z, 
        xo = seq(min(x)-5, max(x)+5, length = gridPoints), 
        yo = seq(min(y), max(y), length = gridPoints)) 

    # Plot:
    persp(ans, theta = 40, xlab = "N", ylab = "q", zlab = "p-Value",
        main = paste(trend, "|", statistic, "ADF"))
    
    # Return Value:
    invisible(NULL)
}



# ------------------------------------------------------------------------------


padf = 
function(q, N = Inf, trend = c("nc", "c", "ct"), statistic = c("t", "n"))
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Returns probabilities  for the ADF Test given quantiles
    
    # Arguments:
    #   q = quantiles (-2.66 < q < 2.16)
    #   N = sample sizes
    
    # Example:
    #   padf(q = -2:2, N = 1000) 
    #   padf(q = -2:2, N = 100)
    #   padf(q = -2:2, N = 20)
    #   padf(-3, 100)
    #   q=c(-2:2); for (N in c(20, 100, 1000, 5000, Inf)) print(padf(q, N)) 
    
    # FUNCTION:
    
    # Match Arguments:
    trend = match.arg(trend)
    statistic = match.arg(statistic)
    
    # Check N:
    stopifnot(length(N) == 1)
    
    # Grid Points:
    X = adfTable(trend = trend, statistic = statistic)
    if (N < 500) {
        finiteX = cbind(expand.grid(x = X$x, y = X$y), z = as.vector(X$z))
        X = finiteX[is.finite(finiteX[, 1]), ]
        y = X[, 1] # N
        z = X[, 2] # p-Value
        x = X[, 3] # q-Stat
        # Out Points:
        xo = q
        yo = rep(N, times = length(q))
        # Interpolate:
        p = linearInterpp(x, y, z, xo = xo, yo = yo)[, 3]
    } else {
        x = X$z["Inf", ]
        y = X$y
        p = approx(x, y, xout = q)$y  
    }
    
    # Result:
    names(p) = as.character(q)
    attr(p, "control") <- c(N = N)
 
    # Return Value:
    p
} 


# ------------------------------------------------------------------------------


qadf = 
function(p, N = Inf, trend = c("nc", "c", "ct"), statistic = c("t", "n")) 
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Returns quantiles for the ADF Test given probabilities
    
    # Arguments:
    #   p = probabilities (0.01 < p < 0.99)
    #   N = sample sizes
    
    # Example:
    #   qadf(p = (1:9)/10, N = 1000) 
    #   qadf(p = (1:9)/10, N = 100)
    #   qadf(p = (1:9)/10, N = 20)
    #   qadf(0.001, 100)
    #   qadf(0.001, 1000)
    
    # FUNCTION:
    
    # Match Arguments:
    trend = match.arg(trend)
    statistic = match.arg(statistic)
    
    # Check N:
    stopifnot(length(N) == 1)
    
    # Grid Points:
    X = adfTable(trend = trend, statistic = statistic)
    if (N < 500) {
        finiteX = cbind(expand.grid(x = X$x, y = X$y), z = as.vector(X$z))
        X = finiteX[is.finite(finiteX[, 1]), ]
        x = X[, 1]
        y = X[, 2]
        z = X[, 3]
        # Out Points:
        xo = rep(N, times = length(p))
        yo = p
        # Interpolate:
        q = linearInterpp(x, y, z, xo = xo, yo = yo)[, 3]
    } else {
        x = X$y
        y = X$z["Inf", ]
        q = approx(x, y, xout = p)$y    
    }
    
    # Result:
    names(q) = as.character(p)
    attr(q, "control") <- c(N = N)
    
    # Return Value:
    q
} 


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file 


################################################################################
# FUNCTION:            AUGMENTED DICKEY FULLER DATA TABLES:
# adfTable              Finite sample p values for the Dickey-Fuller test
# .adfPlot              Plots sample p values for the Dickey-Fuller test
# padf                  Returns probabilities  for the ADF Test given quantiles
# qadf                  Returns quantiles for the ADF Test given probabilities
################################################################################


test.adfTable = 
function()
{ 
    # Dickey-Fuller Test Tables:
    #   adfTable(trend = c("nc", "c", "ct"), statistic = c("t", "n"),
    #       includeInf = TRUE)
    
    Table = adfTable("nc", "t")
    print(Table)
    target = sum(Table$z)
    print(target)
    current = -15.11
    checkEqualsNumeric(target, current)
    
    Table = adfTable("c", "t")
    print(Table)
    target = sum(Table$z)
    print(target) 
    current = -70.55
    checkEqualsNumeric(target, current)
    
    Table = adfTable("ct", "t")
    print(Table)
    target = sum(Table$z)
    print(target)
    current = -104.68
    checkEqualsNumeric(target, current)
    
    Table = adfTable("nc", "n")
    print(Table)
    target = sum(Table$z)
    print(target)
    current = -184.07
    checkEqualsNumeric(target, current)
    
    Table = adfTable("c", "n")
    print(Table)
    target = sum(Table$z)
    print(target)
    current = -357.11 
    checkEqualsNumeric(target, current)
    
    Table = adfTable("ct", "n")
    print(Table)
    target = sum(Table$z)
    print(target)
    current = -582.60
    checkEqualsNumeric(target, current)
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.adfPlot =
function()
{
    if (FALSE) {
        
        require(akima)
        
        # .adfPlot(trend = c("nc", "c", "ct"), statistic = c("t", "n"))
    
        par(mfrow = c(1, 1))
        for (trend in c("nc", "c", "ct")) {
            for (statistic in c("t", "n")) {
                .adfPlot(trend, statistic)
            }
        }
        
    }
    
    # Return Value:
    return()  
    
}


# ------------------------------------------------------------------------------


test.adfQuantiles = 
function()
{    
    if (FALSE) {
        
        require(akima)
        
        # padf(q, n.sample, trend = c("nc", "c", "ct"), statistic = c("t", "n")) 
        # qadf(p, n.sample, trend = c("nc", "c", "ct"), statistic = c("t", "n"))
        
        p = 0.984
        n.sample = 78
        for (trend in c("nc", "c", "ct")) {
            for (statistic in c("t", "n")) {
                cat(trend, statistic, ": ")
                Q = qadf(p, n.sample, trend, statistic)
                target = P = padf(Q, n.sample, trend, statistic)
                cat(c(Q, P), 
                    checkEqualsNumeric(target, current = p, tolerance = 1e-3), "\n")
            }
        }
        
    }
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.interpolationQuantiles = 
function()
{      
    if (FALSE) {
        
        require(akima)
        
        # Extrapolation: Quantiles
        adfTable()
        check = c(NA, NA, NA, -2.66, NA, 2.16, NA, NA)
        ans = NULL
        for (p in c(0.005, 0.010, 0.990, 0.995)) {
            for (n.sample in c(10, 25)) {
                Q = qadf(p, n.sample)
                ans = rbind(ans, c(p, n.sample, Q))
            }
        }
        ans = cbind(ans, check)
        ans
        checkEqualsNumeric(target = ans[, 3], current = ans[, 4])
    
        # (Extra)Interpolation: Probabilities - uses linearInterpp()
        A = padf(q = -2.70, N = 100)  # NA
        print(A)
        B = padf(q =  2.03, N = 100)  # 0.99 
        print(B)
        C = padf(q = -1.50, N =  10)  # NA
        print(C)
        D = padf(q = -1.60, N = Inf)  # 0.1064
        print(D)
        target = c(A[[1]], B[[1]], C[[1]], D[[1]])
        current = c(NA, 0.99, NA, 0.1063745)
        checkEqualsNumeric(target, current, tolerance = 1e-4)
        
    }
    
    # Return Value:
    return()    
}


################################################################################

pkg <- "fUnitRoots"

if(require("RUnit", quietly = TRUE))
{

    library(package=pkg, character.only = TRUE)
    if(!(exists("path") && file.exists(path)))
        path <- system.file("unitTests", package = pkg)

    ## --- Testing ---

    ## Define tests
    testSuite <- defineTestSuite(name = paste(pkg, "unit testing"),
                                 dirs = path)

    if(interactive()) {
        cat("Now have RUnit Test Suite 'testSuite' for package '",
            pkg, "' :\n", sep='')
        str(testSuite)
        cat('', "Consider doing",
            "\t  tests <- runTestSuite(testSuite)", "\nand later",
            "\t  printTextProtocol(tests)", '', sep = "\n")
    } else {
        ## run from shell / Rscript / R CMD Batch / ...
        ## Run
        tests <- runTestSuite(testSuite)

        if(file.access(path, 02) != 0) {
            ## cannot write to path -> use writable one
            tdir <- tempfile(paste(pkg, "unitTests", sep="_"))
            dir.create(tdir)
            pathReport <- file.path(tdir, "report")
            cat("RUnit reports are written into ", tdir, "/report.(txt|html)",
                sep = "")
        } else {
            pathReport <- file.path(path, "report")
        }

        ## Print Results:
        printTextProtocol(tests, showDetails = FALSE)
        printTextProtocol(tests, showDetails = FALSE,
                          fileName = paste(pathReport, "Summary.txt", sep = ""))
        printTextProtocol(tests, showDetails = TRUE,
                          fileName = paste(pathReport, ".txt", sep = ""))

        ## Print HTML Version to a File:
        ## printHTMLProtocol has problems on Mac OS X
        if (Sys.info()["sysname"] != "Darwin")
        printHTMLProtocol(tests,
                          fileName = paste(pathReport, ".html", sep = ""))

        ## stop() if there are any failures i.e. FALSE to unit test.
        ## This will cause R CMD check to return error and stop
        tmp <- getErrors(tests)
        if(tmp$nFail > 0 | tmp$nErr > 0) {
            stop(paste("\n\nunit testing failed (#test failures: ", tmp$nFail,
                       ", R errors: ",  tmp$nErr, ")\n\n", sep=""))
        }
    }
} else {
    cat("R package 'RUnit' cannot be loaded -- no unit tests run\n",
        "for package", pkg,"\n")
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:                URCA [PFAGFF] UNIT ROOT TESTS:
#  urdfTest                 Augmented Dickey-Fuller test for unit roots
#  urersTest                Elliott-Rothenberg-Stock test for unit roots
#  urkpssTest               KPSS unit root test for stationarity
#  urppTest                 Phillips-Perron test for unit roots
#  urspTest                 Schmidt-Phillips test for unit roots
#  urzaTest                 Zivot-Andrews test for unit roots
################################################################################


require(urca)


pvalue = 
function(object) 
{   # A function implemented by Diethelm Wuertz

    # FUNCTION:
    
    # Return Value: 
    UseMethod("pvalue") 
}


statistic = 
function(object) 
{   # A function implemented by Diethelm Wuertz

    # FUNCTION:
    
    # Return Value: 
    UseMethod("statistic") 
}


pvalue.fHTEST = 
function(object) 
{   # A function implemented by Diethelm Wuertz

    # FUNCTION:
    
    # p Value:
    pValue = object@test$p.value 
    pNames = names(pValue)
    for (i in 1:length(pValue)) {
        if (is.null(pNames[i]) || pNames[i] == "") pNames[i] = "p.value"
    }
    names(pValue)<-pNames
    
    # Return Value:
    pValue        
}


statistic.fHTEST = 
function(object) 
{   # A function implemented by Diethelm Wuertz

    # FUNCTION:
    
    # Statistic:
    statistic = object@test$statistic 
    
    # Return Value:
    statistic
}


################################################################################


test.urdfTest = 
function()
{
    # A time series which contains no unit-root:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = rnorm(100)  
    
    # A time series which contains a unit-root:
    y = cumsum(c(0, x))
    
    # DF Test:
    urdfTest(x, lags = 1, type = c("nc", "c", "ct"), 
        doplot = TRUE)                                                   

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.urersTest = 
function()
{
    # A time series which contains no unit-root:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = rnorm(100)  
    
    # A time series which contains a unit-root:
    y = cumsum(c(0, x))
            
    # ERS Test:
    urersTest(x, type = "DF-GLS", model = c("constant", "trend"),
        lag.max = 4, doplot = TRUE)
    urersTest(x, type = "P-test", model = c("constant", "trend"),
        lag.max = 4) # No Plot
        
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.urkpssTest = 
function()
{
    # A time series which contains no unit-root:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = rnorm(100)  
    
    # A time series which contains a unit-root:
    y = cumsum(c(0, x))
         
    # KPSS Test:   
    urkpssTest(x, type = "mu", lags = c("short", "long", "nil"),
        use.lag = NULL, doplot = TRUE)
    urkpssTest(x, type = "tau", lags = c("short", "long", "nil"),
        use.lag = NULL) # No Plot
      
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.urppTest = 
function()
{
    # A time series which contains no unit-root:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = rnorm(100)  
    
    # A time series which contains a unit-root:
    y = cumsum(c(0, x))
    
    # PP Test:  
    urppTest(x, type = "Z-alpha", model = c("constant", "trend"),
        lags = c("short", "long"), use.lag = NULL, doplot = TRUE)
    urppTest(x, type = "Z-tau", model = c("constant", "trend"),
        lags = c("short", "long"), use.lag = NULL, doplot = TRUE)
        
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.urspTest = 
function()
{
    # A time series which contains no unit-root:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = rnorm(100)  
    
    # A time series which contains a unit-root:
    y = cumsum(c(0, x))
    
    # SP Test:  
    urspTest(x, type = "tau", pol.deg = c(1, 2, 3, 4),
        signif = c(0.01, 0.05, 0.1), doplot = TRUE)
    urspTest(x, type = "rho", pol.deg = c(1, 2, 3, 4),
        signif = c(0.01, 0.05, 0.1), doplot = TRUE)
        
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.urzaTest = 
function()
{        
    # A time series which contains no unit-root:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = rnorm(100)  
    
    # A time series which contains a unit-root:
    y = cumsum(c(0, x))
    
    # ZA Test: 
    urzaTest(x, model = "intercept", lag = 2, 
        doplot = TRUE) 
    urzaTest(x, model = "trend", lag = 2, 
        doplot = TRUE) 
    urzaTest(x, model = "both", lag = 2, 
        doplot = TRUE)   

    # Return Value:
    return()    
}


################################################################################
    

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# A copy of the GNU General Public License is available via WWW at
# http://www.gnu.org/copyleft/gpl.html.  You can also obtain it by
# writing to the Free Software Foundation, Inc., 59 Temple Place,
# Suite 330, Boston, MA  02111-1307  USA.


################################################################################
# FUNCTION:                URCA INTERFACE [PFAFF] UNIT ROOT TESTS:
#  urdfTest                 Performs Augmented Dickey-Fuller test for unit roots
#  urersTest                Performs Elliott-Rothenberg-Stock test for unit roots
#  urkpssTest               Performs KPSS unit root test for stationarity
#  urppTest                 Performs Phillips-Perron test for unit roots
#  urspTest                 Performs Schmidt-Phillips test for unit roots
#  urzaTest                 Performs Zivot-Andrews test for unit roots
################################################################################


# NOTE, THIS INTERFACE REQUIRES THE URCA PACKAGE !


urdfTest <-
    function(x, lags = 1, type = c("nc", "c", "ct"), doplot = TRUE)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Dickey-Fuller test for unit roots

    # Notes:
    #   Requires "urca" which is not part of this distribution
    #   Wraps -
    #       urca::ur.df(y, type = c("none", "drift", "trend"), lags = 1)

    # FUNCTION:

    # Compute:
    x <- as.vector(x)
    if (type[1] == "nc") Type <- "none"
    if (type[1] == "c")  Type <- "drift"
    if (type[1] == "ct") Type <- "trend"

    urca <- urca::ur.df(x, type = Type, lags = lags)
    output <- capture.output(summary(urca))[-(1:4)]
    for (i in 1:length(output)) output[i] = paste(" ", output[i])
    output <- output[-length(output)][-3]

    # Test Results:
    ans <- list(
        name = "ur.df",
        test = urca,
        output = output
    )

    # Plot:
    if (doplot) plot(urca)

    # Return Value:
    new("fHTEST",
        call = match.call(),
        data = list(x = x),
        test = ans,
        title = "Augmented Dickey-Fuller Unit Root Test",
        description = description()
    )
}


# -----------------------------------------------------------------------------


urersTest <- 
    function(x, type = c("DF-GLS", "P-test"), model = c("constant", "trend"),
    lag.max = 4, doplot = TRUE)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Elliott-Rothenberg-Stock test for unit roots

    # Notes:
    #   Requires "urca" which is not part of this distribution
    #   Wraps -
    #       urca::ur.ers(y, type = c("DF-GLS", "P-test"),
    #       model = c("constant", "trend"), lag.max = 4)

    # FUNCTION:

    # Compute:
    x <- as.vector(x)
    urca <- urca::ur.ers(x, type = type[1], model = model[1], lag.max = lag.max)
    output <- capture.output(summary(urca))[-(1:4)]
    for (i in 1:length(output)) output[i] = paste(" ", output[i])
    output <- output[-length(output)]
    if (type[1] == "DF-GLS") output = output[-(4:7)]

    # Test Results:
    ans <- list(
        name = "ur.ers",
        test = urca,
        output = output
    )
#browser()
    # Plot:
    if (doplot & type[1] == "DF-GLS") plot(urca)

    # Return Value:
    new("fHTEST",
        call = match.call(),
        data = list(x = x),
        test = ans,
        title = "Elliott-Rothenberg-Stock Unit Root Test",
        description = description()
    )
}


# -----------------------------------------------------------------------------


urkpssTest <- 
    function(x, type = c("mu", "tau"), lags = c("short", "long", "nil"),
    use.lag = NULL, doplot = TRUE)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   KPSS unit root test for stationarity

    # Notes:
    #   Requires "urca" which is not part of this distribution
    #   Wraps:
    #       urca::ur.kpss(y, type = c("mu", "tau"), lags = c("short", "long", "nil"),
    #       use.lag = NULL)

    # FUNCTION:

    # Compute:
    x <- as.vector(x)
    urca <- urca::ur.kpss(x, type = type[1], lags = lags[1], use.lag = use.lag)
    output = capture.output(summary(urca))[-(1:4)]
    output = output[-length(output)]
    for (i in 1:length(output)) output[i] = paste(" ", output[i])

    # Test Results:
    ans = list(
        name = "ur.kpss",
        test = urca,
        output = output
    )

    # Plot:
    if (doplot) plot(urca)

    # Return Value:
    new("fHTEST",
        call = match.call(),
        data = list(x = x),
        test = ans,
        title = "KPSS Unit Root Test",
        description = description()
    )
}


# -----------------------------------------------------------------------------


urppTest <- 
    function(x, type = c("Z-alpha", "Z-tau"), model = c("constant", "trend"),
    lags = c("short", "long"), use.lag = NULL, doplot = TRUE)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Phillips-Perron test for unit roots

    # Note:
    #   Requires "urca" which is not part of this distribution
    #   Wraps:
    #       urca::ur.pp(x, type = c("Z-alpha", "Z-tau"), model = c("constant",
    #       "trend"), lags = c("short", "long"), use.lag = NULL)

    # FUNCTION:

    # Compute:
    x <- as.vector(x)
    urca <- urca::ur.pp(x, type = type[1], model = model[1], lags = lags[1],
        use.lag = use.lag)
    output <- capture.output(summary(urca))[-c(1:4, 7:10)]
    for (i in 1:length(output)) output[i] = paste(" ", output[i])
    output <- output[-length(output)]

    # Test Results:
    ans <- list(
        name = "ur.pp",
        test = urca,
        output = output
    )

    # Plot:
    if (doplot) plot(urca)

    # Return Value:
    new("fHTEST",
        call = match.call(),
        data = list(x = x),
        test = ans,
        title = "Phillips-Perron Unit Root Test",
        description = description()
    )
}


# -----------------------------------------------------------------------------


urspTest =
    function(x, type = c("tau", "rho"), pol.deg = c(1, 2, 3, 4),
    signif = c(0.01, 0.05, 0.10), doplot = TRUE)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Schmidt-Phillips test for unit roots

    # Note:
    #   Requires "urca" which is not part of this distribution
    #   Wraps:
    #       urca::ur.sp(y, type = c("tau", "rho"), pol.deg = c(1, 2, 3, 4),
    #       signif = c(0.01, 0.05, 0.1))

    # FUNCTION:

    # Compute:
    x <- as.vector(x)
    urca <- urca::ur.sp(
      x, type = type[1], pol.deg = pol.deg[1], signif = signif[1])
    output <- capture.output(summary(urca))[-(1:8)]
    output <- output[-length(output)]
    for (i in 1:length(output)) output[i] = paste(" ", output[i])

    # Test Results:
    ans <- list(
        name = "ur.pp",
        test = urca,
        output = output
    )

    # Plot:
    if (doplot) plot(urca)

    # Return Value:
    new("fHTEST",
        call = match.call(),
        data = list(x = x),
        test = ans,
        title = "Schmidt-Phillips Unit Root Test",
        description = description()
    )
}


# -----------------------------------------------------------------------------


urzaTest <- 
function(x, model = c("intercept", "trend", "both"), lag = 2, doplot = TRUE)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Zivot-Andrews test for unit roots

    # Note:
    #   Requires "urca" which is not part of this distribution
    #   Wraps:
    #       urca::ur.za(y, model = c("intercept", "trend", "both"), lag)

    # FUNCTION:

    # Compute:
    x <- as.vector(x)
    urca <- urca::ur.za(x, model = model[1], lag = lag)
    output <- capture.output(summary(urca))[-(1:8)]
    output <- output[-length(output)]
    for (i in 1:length(output)) output[i] = paste(" ", output[i])

    # Test Results:
    ans <- list(
        name = "ur.pp",
        test = urca,
        output = output
    )

    # Plot:
    if (doplot) plot(urca)

    # Return Value:
    new("fHTEST",
        call = match.call(),
        data = list(x = x),
        test = ans,
        title = "Zivot & Andrews Unit Root Test",
        description = description()
    )
}


###############################################################################

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# A copy of the GNU General Public License is available via WWW at
# http://www.gnu.org/copyleft/gpl.html.  You can also obtain it by
# writing to the Free Software Foundation, Inc., 59 Temple Place,
# Suite 330, Boston, MA  02111-1307  USA.


################################################################################
# FUNCTION:                ADF TESTS:
#  adfTest                  ADF unit root test using Banarjee's test statistics
#  unitrootTest             ADF unit root test using McKinnon's test statistics
# FUNCTION:                UNITROOT TEST SUITE:
#  .urTest                  Unit Root Test Suite
################################################################################


adfTest <-
    function(x, lags = 1, type = c("nc", "c", "ct"), title = NULL,
    description = NULL)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Tests the null hypothesis of a unit root in y.

    # Arguments:
    #   x - numeric vector
    #   type - specifies the regression model to be estimatied and the
    #       null hypothesis, "nc" no constant and no trend, "c" add
    #       constant, "ct" add constant and trend.
    #   lags - specifies the number of lagged differences of x to be
    #       included in the regression model. If 'lags' = h, a term
    #       sum_{i=1}^{h-1} beta_i * diff(x)_(t-h) is added to the
    #       regression equation.

    # Value:
    #   A list of class "htest" containing the following components:
    #   statistic - the value of the test statistic (t-statistic)
    #   parameter - the number of lags.
    #   p.value - the p-value of the test
    #   method - a character string indicating what type of test was performed
    #   data.name - a character string giving the name of the data y

    # Reference:
    #   S. E. SAID and D. A. DICKEY (1984): Testing for Unit Roots in
    #   Autoregressive-Moving Average Models of Unlag.diffnown Order.
    #   Biometrika 71, 599?607.

    # Source:
    #   This function is an augmented version of Adrian Trapletti's
    #   function adf.test() which considers type "ct" only. We have added
    #   the types "c" and "nc" together with the appropriate statistics.

    # Call:
    CALL <- match.call()

    # Test:
    test <- list()

    # Data Set Name:
    DNAME <- deparse(substitute(x))
    test$data.name <- DNAME

    # Transform:
    if (class(x) == "timeSeries") x = series(x)
    x = as.vector(x)

    # Check Arguments:
    if (lags < 0) stop("Lags are negative")

    # Settings:
    doprint <- FALSE
    type <- type[1]
    lags <- lags + 1
    y <- diff(x)
    n <- length(y)
    z <- embed(y, lags)
    y.diff <- z[, 1]
    y.lag.1 <- x[lags:n]
    tt <- lags:n

    # Regression:
    if (lags > 1) {
        y.diff.lag = z[,2:lags]
        if (type == "nc"){
            res = lm(y.diff ~ y.lag.1 - 1 + y.diff.lag) }
        if (type == "c"){
            res = lm(y.diff ~ y.lag.1 + 1 +  y.diff.lag) }
        if (type == "ct") {
            res = lm(y.diff ~ y.lag.1 + 1 + tt + y.diff.lag) }
    } else {
        if (type == "nc") {
            res = lm(y.diff ~ y.lag.1 - 1) }
        if (type == "c"){
            res = lm(y.diff ~ y.lag.1 + 1) }
        if (type == "ct") {
            res = lm(y.diff ~ y.lag.1 + 1  + tt)  }
    }

    # Regression Summary:
    res.sum <- summary(res)
    if (doprint) print(res.sum)

    # Statistic:
    if (type == "nc") coefNum = 1 else coefNum = 2
    STAT <- res.sum$coefficients[coefNum, 1] / res.sum$coefficients[coefNum, 2]
    names(STAT) <- "Dickey-Fuller"
    test$statistic <- STAT

    # P Value:
    if (type == "nc")
        table = cbind(
            c(-2.66, -2.26, -1.95, -1.60, +0.92, +1.33, +1.70, +2.16),
            c(-2.62, -2.25, -1.95, -1.61, +0.91, +1.31, +1.66, +2.08),
            c(-2.60, -2.24, -1.95, -1.61, +0.90, +1.29, +1.64, +2.03),
            c(-2.58, -2.23, -1.95, -1.62, +0.89, +1.29, +1.63, +2.01),
            c(-2.58, -2.23, -1.95, -1.62, +0.89, +1.28, +1.62, +2.00),
            c(-2.58, -2.23, -1.95, -1.62, +0.89, +1.28, +1.62, +2.00))
    if (type == "c")
        table = cbind(
            c(-3.75, -3.33, -3.00, -2.63, -0.37, +0.00, +0.34, +0.72),
            c(-3.58, -3.22, -2.93, -2.60, -0.40, -0.03, +0.29, +0.66),
            c(-3.51, -3.17, -2.89, -2.58, -0.42, -0.05, +0.26, +0.63),
            c(-3.46, -3.14, -2.88, -2.57, -0.42, -0.06, +0.24, +0.62),
            c(-3.44, -3.13, -2.87, -2.57, -0.43, -0.07, +0.24, +0.61),
            c(-3.43, -3.12, -2.86, -2.57, -0.44, -0.07, +0.23, +0.60))
    if (type == "ct")
        table = cbind(
            c(-4.38, -3.95, -3.60, -3.24, -1.14, -0.80, -0.50, -0.15),
            c(-4.15, -3.80, -3.50, -3.18, -1.19, -0.87, -0.58, -0.24),
            c(-4.04, -3.73, -3.45, -3.15, -1.22, -0.90, -0.62, -0.28),
            c(-3.99, -3.69, -3.43, -3.13, -1.23, -0.92, -0.64, -0.31),
            c(-3.98, -3.68, -3.42, -3.13, -1.24, -0.93, -0.65, -0.32),
            c(-3.96, -3.66, -3.41, -3.12, -1.25, -0.94, -0.66, -0.33))
    table = t(table)
    tablen = dim(table)[2]
    tableT = c(25, 50, 100, 250, 500, 1e+05)
    tablep = c(0.01, 0.025, 0.05, 0.1, 0.9, 0.95, 0.975, 0.99)
    tableipl = numeric(tablen)
    for (i in (1:tablen))
        tableipl[i] = approx(tableT, table[, i], n, rule = 2)$y
    PVAL = approx(tableipl, tablep, STAT, rule = 2)$y
    if (is.na(approx(tableipl, tablep, STAT, rule = 1)$y)) {
        if (PVAL == min(tablep)) {
            warning("p-value smaller than printed p-value")
        } else {
            warning("p-value greater than printed p-value")
        }
    }
    names(PVAL) = ""
    test$p.value = PVAL

    # Parameter:
    PARAMETER = lags - 1
    names(PARAMETER) = "Lag Order"
    test$parameter = PARAMETER

    # Add:
    if (is.null(title)) title = "Augmented Dickey-Fuller Test"
    if (is.null(description)) description = date()

    # Add Regression:
    test$lm = res

    # Return Value:
    new("fHTEST",
        call = CALL,
        data = list(x = x),
        test = test,
        title = as.character(title),
        description = description()
        )
}


# ------------------------------------------------------------------------------


unitrootTest =
    function(x, lags = 1, type = c("nc", "c", "ct"), title = NULL,
    description = NULL)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Tests the null hypothesis of a unit root in x.

    # Arguments:
    #   x - numeric vector
    #   type - specifies the regression model to be estimatied and the
    #       null hypothesis, "nc" no constant and no trend, "c" add
    #       constant, "ct" add constant and trend.
    #   lags - specifies the number of lagged differences of x to be
    #       included in the regression model. If 'lags' = h, a term
    #       sum_{i=1}^{h-1} beta_i * diff(x)_(t-h) is added to the
    #       regression equation.

    # Value:
    #   A list with class "htest" containing the following components:
    #   statistic - the value of the test statistic (t-statistic)
    #   parameter - the number of lags.
    #   p.value - the p-value of the test
    #   method - a character string indicating what "trend" type of
    #       the test was performed
    #   data.name - a character string giving the name of the data y

    # Reference:
    #   Said S.E., Dickey D.A. (1984): Testing for Unit Roots in
    #   Autoregressive-Moving Average Models of Unlag.diffnown Order.
    #   Biometrika 71, 599?-607.

    # Source:
    #   This function is an augmented version of Adrian Trapletti's
    #   function adf.test() which considers trend "ct" only. We have added
    #   the trend types "c" and "nc" together with the appropriate statistics.

    # FUNCTION:

    # Call:
    CALL <- match.call()

    # Test:
    test <- list()

    # Data Set Name:
    DNAME <- deparse(substitute(x))
    test$data.name <- DNAME

    # Transform:
    if (class(x) == "timeSeries") x <- series(x)
    x = as.vector(x)

    # Check Arguments:
    if (lags < 0) stop("Lags are negative")

    # Settings:
    type = type[1]
    lags = lags + 1
    y = diff(x)
    n = length(y)
    z = embed(y, lags)
    y.diff = z[, 1]
    y.lag.1 = x[lags:n]
    tt = lags:n

    # Regression:
    if (lags > 1) {
        y.diff.lag = z[,2:lags]
        if (type == "nc"){
            res = lm(y.diff ~ y.lag.1 - 1 + y.diff.lag) }
        if (type == "c"){
            res = lm(y.diff ~ y.lag.1 + 1 +  y.diff.lag) }
        if (type == "ct") {
            res = lm(y.diff ~ y.lag.1 + 1 + tt + y.diff.lag) }
        if (type == "ctt") {
            res = lm(y.diff ~ y.lag.1 + 1 + tt + tt^2 + y.diff.lag) }
    } else {
        if (type == "nc") {
            res = lm(y.diff ~ y.lag.1 - 1) }
        if (type == "c"){
            res = lm(y.diff ~  y.lag.1 + 1) }
        if (type == "ct") {
            res = lm(y.diff ~ y.lag.1 + 1  + tt)  }
        if (type == "ctt") {
            res = lm(y.diff ~ y.lag.1 + 1 + tt + tt^2) }
    }
    res.sum = summary(res)
    test$regression = res.sum

    # Statistic:
    if (type == "nc") coefNum = 1 else coefNum = 2
    STATISTIC <- 
        res.sum$coefficients[coefNum, 1] / res.sum$coefficients[coefNum, 2]
    names(STATISTIC) = "DF"
    test$statistic = STATISTIC

    # P Value:
    if (type == "nc") { itv = 1 }
    if (type == "c")  { itv = 2 }
    if (type == "ct") { itv = 3 }
    if (type == "ctt"){ itv = 4 }
    # Statistic == "t" : itt = 1
    PVAL1 =
        .urcval(arg = STATISTIC, nobs = n, niv = 1, itt = 1, itv = itv, nc = 2)
    # Statistic == "n" : itt = 2
    PVAL2 =
        .urcval(arg = STATISTIC, nobs = n, niv = 1, itt = 2, itv = itv, nc = 2)
    PVAL <- c(PVAL1, PVAL2)
    names(PVAL) = c("t", "n")
    test$p.value = PVAL

    # Parameter:
    PARAMETER <- lags - 1
    names(PARAMETER) <- "Lag Order"
    test$parameter <- PARAMETER

    # Add:
    if (is.null(title)) title = "Augmented Dickey-Fuller Test"
    if (is.null(description)) description = date()

    # Return Value:
    new("fHTEST",
        call = CALL,
        data = list(x = x),
        test = test,
        title = as.character(title),
        description = description()
        )
}


################################################################################


.urTest =
    function(x, method = c("unitroot", "adf", "urers", "urkpss", "urpp",
    "ursp", "urza"), title = NULL, description = NULL, ...)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Unit Root Test Suite

    # FUNCTION:

    # Match Function:
    funTest <- match.fun(paste(method[1], "Test", sep = ""))

    # Test:
    ans <- funTest(x = x, ...)

    # Add:
    if (!is.null(title)) ans@title = as.character(title)
    if (!is.null(description)) ans@description = description()

    # Return Value:
    ans
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:                ADF TESTS:
#  adfTest                  ADF unit root test using Banarjee's test statistics
#  unitrootTest             ADF unit root test using McKinnon's test statistics
################################################################################


pvalue = 
function(object) 
{   # A function implemented by Diethelm Wuertz

    # FUNCTION:
    
    # Return Value: 
    UseMethod("pvalue") 
}


# ------------------------------------------------------------------------------


pvalue.fHTEST = 
function(object) 
{   # A function implemented by Diethelm Wuertz

    # FUNCTION:
    
    # p Value:
    pValue = object@test$p.value 
    pNames = names(pValue)
    for (i in 1:length(pValue)) {
        if (is.null(pNames[i]) || pNames[i] == "") pNames[i] = "p.value"
    }
    names(pValue)<-pNames
    
    # Return Value:
    pValue        
}


################################################################################


test.adfTest = 
function()
{  
    # A time series which contains no unit-root:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = rnorm(1000)  
    
    # A time series which contains a unit-root:
    y = cumsum(c(0, x))
    
    # Test x:
    A = adfTest(x)
    print(A)
    target = round(pvalue(A), 3)
    print(target)
    current = 0.010
    checkEqualsNumeric(target, current)
    
    # Test x:
    B = adfTest(y)
    print(B)
    target = round(pvalue(B), 3)
    print(target)
    current = 0.018
    checkEqualsNumeric(target, current)
   
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------
 
    
test.unitrootTest = 
function()
{     
    # A time series which contains no unit-root:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = rnorm(1000)  
    
    # A time series which contains a unit-root:
    y = cumsum(c(0, x))
    
    # Test x:
    A = unitrootTest(x)
    print(A)
    target = pvalue(A)[1]
    print(target)
    current = 0.001
    checkTrue(target < current)
    target = pvalue(A)[2]
    print(target)
    current = 0.001
    checkTrue(target < current)
    
    # Test x:
    B = unitrootTest(y)    
    print(B)
    target = pvalue(B)[1]
    print(target)
    current = 0.01
    checkTrue(target > current)
    target = pvalue(B)[2]
    print(target)
    current = 0.01
    checkTrue(target > current)
   
    # Return Value:
    return()    
}


################################################################################
    

c 2012-12-10 YC: added R print and exit functions

c Copyright (c) James G. MacKinnon, 1996 (corrected 2001-1-8)
c
c urcrouts.f: This is a set of subroutines to estimate critical values
c and P values for unit root and cointegration tests. It is written in
c Fortran 77. Simply call urcval, specifying the first seven arguments.
c The result comes back in the last argument.
c
c A standalone program called urcdist.f is also available.
c
c These routines and the associated data files may be used freely for
c non-commercial purposes, provided that proper attribution is made.
c Please cite the paper
c
c  James G. MacKinnon, "Numerical distribution functions for unit root
c  and cointegration tests," Journal of Applied Econometrics, 11,
c  1996, 601-618.
c
c The routines and datas may not be incorporated into any book
c or computer program without the express, written consent of the author.
c
c The routines must have access to the files probs.tab and .urc-#.tab
c for # = 1, 2, 3 ..., 12. As currently written, these files must be
c in the current directory or in the directory /usr/local/urcdist. Make
c sure that these files are in the proper format for your computer (i.e.
c that lines are terminated by CR/LF for DOS, Windows, and OS/2 systems
c and by LF alone for Unix systems).
c


C ******************************************************************************


      subroutine fcrit(probs, cnorm, beta, wght, cval, size,
     &  precrt, nobs, model, nreg, np, nx)

      implicit real(8) (a-h,o-z)
c
c Copyright (c) James G. MacKinnon, 1995
c Routine to find a critical value for any specified test size.
c Uses GLS to estimate approximating regression.
c
      real(8) probs(221), cnorm(221), beta(4,221), crits(221), wght(221)
      real(8) yvect(20),xmat(20,4),xomx(4,4),resid(20),gamma(4)
      real(8) omega(20,20), fits(20)
      diffm = 1000.d0
      imin = 0
      do i=1,221
      diff = abs(size - probs(i))
      if (diff.lt.diffm) then
         diffm = diff
         imin = i
         if (diffm.lt.1.d-6) go to 100
      end if
      end do
  100 continue
c
      nph = np/2
      nptop = 221 - nph
      if (imin.gt.nph.and.imin.lt.nptop) then
c
c imin is not too close to the end. Use np points around stat.
c
        do i=1,np
          ic = imin - nph - 1 + i
          call eval(beta(1,ic),crits(ic),model,nreg,nobs)
          yvect(i) = crits(ic)
          xmat(i,1) = 1.d0
          xmat(i,2) = cnorm(ic)
          xmat(i,3) = xmat(i,2)*cnorm(ic)
          xmat(i,4) = xmat(i,3)*cnorm(ic)
        end do
c
c form omega matrix
c
        do i=1,np
          do j=i,np
            ic = imin - nph - 1 + i
            jc = imin - nph - 1 + j
            top = probs(ic)*(1.d0 - probs(jc))
            bot = probs(jc)*(1.d0 - probs(ic))
            omega(i,j) = wght(ic)*wght(jc)*sqrt(top/bot)
          end do
        end do
        do i=1,np
          do j=i,np
            omega(j,i) = omega(i,j)
          end do
        end do
c
        nx = 4
        call gls(xmat,yvect,omega,gamma,xomx,fits,resid,ssr,ssrt,
     &    np,nx,20,4,0)
c
c check to see if gamma(4) is needed
c
        sd4 = sqrt((ssrt/(np-nx))*xomx(4,4))
        ttest = abs(gamma(4))/sd4
        if (ttest.gt.precrt) then
          call innorz(size,anorm)
          cval = gamma(1) + gamma(2)*anorm + gamma(3)*anorm**2
     &      + gamma(4)*anorm**3
          return
        else
          nx = 3
          call gls(xmat,yvect,omega,gamma,xomx,fits,resid,ssr,ssrt,
     &      np,nx,20,4,1)
          call innorz(size,anorm)
          cval = gamma(1) + gamma(2)*anorm + gamma(3)*anorm**2
          return
        end if
c
c imin is close to one of the ends. Use points from imin +/- nph to end.
c
      else
        if (imin.lt.np) then
          np1 = imin + nph
          if (np1.lt.5) np1 = 5
          do i=1,np1
            call eval(beta(1,i),crits(i),model,nreg,nobs)
            yvect(i) = crits(i)
            xmat(i,1) = 1.d0
            xmat(i,2) = cnorm(i)
            xmat(i,3) = xmat(i,2)*cnorm(i)
            xmat(i,4) = xmat(i,3)*cnorm(i)
          end do
        else
          np1 = 222 - imin + nph
          if (np1.lt.5) np1 = 5
          do i=1,np1
            call eval(beta(1,222-i),crits(222-i),model,nreg,nobs)
            ic = 222 - i
            yvect(i) = crits(ic)
            xmat(i,1) = 1.d0
            xmat(i,2) = cnorm(ic)
            xmat(i,3) = xmat(i,2)*cnorm(ic)
            xmat(i,4) = xmat(i,3)*cnorm(ic)
          end do
        end if
c
c form omega matrix
c
        do i=1,np1
          do j=i,np1
            if (imin.lt.np) then
              top = probs(i)*(1.d0 - probs(j))
              bot = probs(j)*(1.d0 - probs(i))
              omega(i,j) = wght(i)*wght(j)*sqrt(top/bot)
            else
c
c This is to avoid numerical singularities at the upper end
c
              omega(i,j) = 0.d0
              if (i.eq.j) omega(i,i) = 1.d0
            end if
          end do
        end do
        do i=1,np1
          do j=i,np1
            omega(j,i) = omega(i,j)
          end do
        end do
c
        nx = 4
        call gls(xmat,yvect,omega,gamma,xomx,fits,resid,ssr,ssrt,
     &    np1,nx,20,4,0)
c
c check to see if gamma(4) is needed
c
        sd4 = sqrt((ssrt/(np1-nx))*xomx(4,4))
        ttest = abs(gamma(4)/sd4)
        if (ttest.gt.precrt) then
          call innorz(size,anorm)
          cval = gamma(1) + gamma(2)*anorm + gamma(3)*anorm**2
     &      + gamma(4)*anorm**3
          return
        else
          nx = 3
          call gls(xmat,yvect,omega,gamma,xomx,fits,resid,ssr,ssrt,
     &      np1,nx,20,4,1)
          call innorz(size,anorm)
          cval = gamma(1) + gamma(2)*anorm + gamma(3)*anorm**2
          return
        end if
c
      end if
      end


C ******************************************************************************


      subroutine fpval(beta, cnorm, wght, probs, pval, stat,
     &  precrt, nobs, model, nreg, np, nx)
      implicit real(8) (a-h,o-z)
c
c Copyright (c) James G. MacKinnon, 1995
c Routine to find P value for any specified test statistic.
c
      real(8) beta(4,221), crits(221), cnorm(221), wght(221), probs(221)
      real(8) yvect(20),xmat(20,4),resid(20),gamma(4)
      real(8) omega(20,20), fits(20), xomx(4,4)
c
c first, compute all the estimated critical values
c
      do i=1,221
        call eval(beta(1,i),crits(i),model,nreg,nobs)
      end do
c
c find critical value closest to test statistic
c
      diffm = 1000.d0
      imin = 0
      do i=1,221
      diff = abs(stat - crits(i))
      if (diff.lt.diffm) then
         diffm = diff
         imin = i
      end if
      end do
c
      nph = np/2
      nptop = 221 - nph
      if (imin.gt.nph.and.imin.lt.nptop) then
c
c imin is not too close to the end. Use np points around stat.
c
        do i=1,np
          ic = imin - nph - 1 + i
          yvect(i) = cnorm(ic)
          xmat(i,1) = 1.d0
          xmat(i,2) = crits(ic)
          xmat(i,3) = xmat(i,2)*crits(ic)
          xmat(i,4) = xmat(i,3)*crits(ic)
        end do
c
c form omega matrix
c
        do i=1,np
          do j=i,np
            ic = imin - nph - 1 + i
            jc = imin - nph - 1 + j
            top = probs(ic)*(1.d0 - probs(jc))
            bot = probs(jc)*(1.d0 - probs(ic))
            omega(i,j) = wght(ic)*wght(jc)*sqrt(top/bot)
          end do
        end do
        do i=1,np
          do j=i,np
            omega(j,i) = omega(i,j)
          end do
        end do
c
        nx = 4
        call gls(xmat,yvect,omega,gamma,xomx,fits,resid,ssr,ssrt,
     &    np,nx,20,4,0)
c
c check to see if gamma(4) is needed
c
        sd4 = sqrt((ssrt/(np-nx))*xomx(4,4))
        ttest = abs(gamma(4))/sd4
        if (ttest.gt.precrt) then
          crfit = gamma(1) + gamma(2)*stat + gamma(3)*stat**2
     &      + gamma(4)*stat**3
          call ddnor(crfit,pval)
          return
        else
          nx = 3
          call gls(xmat,yvect,omega,gamma,xomx,fits,resid,ssr,ssrt,
     &      np,nx,20,4,1)
          crfit = gamma(1) + gamma(2)*stat + gamma(3)*stat**2
          call ddnor(crfit,pval)
          return
        end if
      else
c
c imin is close to one of the ends. Use points from imin +/- nph to end.
c
        if (imin.lt.np) then
          np1 = imin + nph
          if (np1.lt.5) np1 = 5
          do i=1,np1
            yvect(i) = cnorm(i)
            xmat(i,1) = 1.d0
            xmat(i,2) = crits(i)
            xmat(i,3) = xmat(i,2)*crits(i)
            xmat(i,4) = xmat(i,3)*crits(i)
          end do
        else
          np1 = 222 - imin + nph
          if (np1.lt.5) np1 = 5
          do i=1,np1
            ic = 222 - i
            yvect(i) = cnorm(ic)
            xmat(i,1) = 1.d0
            xmat(i,2) = crits(ic)
            xmat(i,3) = xmat(i,2)*crits(ic)
            xmat(i,4) = xmat(i,3)*crits(ic)
          end do
        end if
c
c form omega matrix
c
        do i=1,np1
          do j=i,np1
            if (imin.lt.np) then
              top = probs(i)*(1.d0 - probs(j))
              bot = probs(j)*(1.d0 - probs(i))
              omega(i,j) = wght(i)*wght(j)*sqrt(top/bot)
            else
c
c This is to avoid numerical singularities at the upper end
c
              omega(i,j) = 0.d0
              if (i.eq.j) omega(i,i) = 1.d0
            end if
          end do
        end do
        do i=1,np1
          do j=i,np1
            omega(j,i) = omega(i,j)
          end do
        end do
c
        nx = 4
        call gls(xmat,yvect,omega,gamma,xomx,fits,resid,ssr,ssrt,
     &    np1,nx,20,4,0)
c
c check to see if gamma(4) is needed
c
        sd4 = sqrt((ssrt/(np1-nx))*xomx(4,4))
        ttest = abs(gamma(4))/sd4
        if (ttest.gt.precrt) then
          crfit = gamma(1) + gamma(2)*stat + gamma(3)*stat**2
     &      + gamma(4)*stat**3
          call ddnor(crfit,pval)
        else
          nx = 3
          call gls(xmat,yvect,omega,gamma,xomx,fits,resid,ssr,ssrt,
     &      np1,nx,20,4,1)
          crfit = gamma(1) + gamma(2)*stat + gamma(3)*stat**2
          call ddnor(crfit,pval)
        end if
c
c check that nothing crazy has happened at the ends
c
        if (imin.eq.1.and.pval.gt.probs(1)) pval = probs(1)
        if (imin.eq.221.and.pval.lt.probs(221)) pval = probs(221)
        return
      end if
      end


C ******************************************************************************


      subroutine eval(beta,cval,model,nreg,nobs)
      implicit real(8) (a-h,o-z)

c
c Copyright (c) James G. MacKinnon, 1995
c Routine to evaluate response surface for specified betas and sample size.
c
      real(8) beta(4)
      if (nobs.eq.0) then
         cval = beta(1)
         return
      end if
      if (model.eq.2) then
         onobs = 1.d0/nobs
         cval = beta(1) + beta(2)*onobs + beta(3)*onobs**2
         return
      end if
      if (model.eq.3) then
         onobs = 1.d0/nobs
         cval = beta(1) + beta(2)*onobs + beta(3)*onobs**2
     &     + beta(4)*onobs**3
         return
      end if
      if (model.eq.4) then
         onobs = 1.d0/(nobs - nreg)
         cval = beta(1) + beta(2)*onobs + beta(3)*onobs**2
         return
      end if
      if (model.eq.5) then
         onobs = 1.d0/(nobs - nreg)
         cval = beta(1) + beta(2)*onobs + beta(3)*onobs**2
     &     + beta(4)*onobs**3
         return
      end if
      ier = 1
      call intpr('*** Warning! Error in input file. ***', -1, ier, 0)
      return
      end


C ******************************************************************************


      subroutine gls(xmat,yvect,omega,beta,xomx,fits,resid,ssr,ssrt,
     &  nobs,nvar,nomax,nvmax,ivrt)
c
c Copyright (c) James G. MacKinnon, 1995
c Subroutine to do GLS estimation the obvious way
c Use only when sample size is small (nobs <= 50)
c 1995-1-3
c
      implicit real(8) (a-h,o-z)
      real(8) xmat(nomax,nvmax), yvect(nomax), omega(nomax,nomax)
      real(8) beta(nvmax), xomx(nvmax,nvmax), fits(nomax), resid(nomax)
      real(8) xomy(50)
c
c xomx is covariance matrix of parameter estimates if omega is truly known
c First, invert omega matrix if ivrt=0. Original one gets replaced.
c
      if (ivrt.eq.0) call cholx(omega,nomax,nobs,kxx)
c
c form xomx matrix and xomy vector
c
      do j=1,nvar
        xomy(j) = 0.d0
        do l=j,nvar
          xomx(j,l) = 0.d0
        end do
      end do
c
      do 21 i=1,nobs
      do 21 k=1,nobs
      do 24 j=1,nvar
      xomy(j) = xomy(j) + xmat(i,j)*omega(k,i)*yvect(k)
      do 24 l=j,nvar
      xomx(j,l) = xomx(j,l) + xmat(i,j)*omega(k,i)*xmat(k,l)
   24 continue
   21 continue
c
      do j=1,nvar
        do l=j,nvar
          xomx(l,j) = xomx(j,l)
        end do
      end do
c
c invert xomx matrix
c
      call cholx(xomx,nvmax,nvar,kxx)
c
c  now form estimates of beta.
c
      do 5 i=1,nvar
      beta(i) = 0.d0
      do 5 j=1,nvar
      beta(i) = beta(i) + xomx(i,j)*xomy(j)
    5 continue
c
c find ssr, fitted values, and residuals
c
      ssr = 0.d0
      do i=1,nobs
        fits(i) = 0.d0
        do j=1,nvar
          fits(i) = fits(i) + xmat(i,j)*beta(j)
        end do
        resid(i) = yvect(i) - fits(i)
        ssr = ssr + resid(i)**2
      end do
c
c find ssr from transformed regression
c
      ssrt = 0.d0
      do i=1,nobs
        do k=1,nobs
          ssrt = ssrt + resid(i)*omega(k,i)*resid(k)
        end do
      end do
c
      return
      end


C ******************************************************************************


      subroutine cholx(amat,m,n,kxx)
      implicit real(8) (a-h,o-z)
c
c     Copyright (c) James G. MacKinnon, 1993
c     This routine uses the cholesky decomposition to invert a real
c     symmetric matrix.
c
      real(8) amat(m,m)
      ooa = 1.d0 ! Wall
      kxx = 0
      do 8 i=1,n
         kl = i - 1
         do 7 j=i,n
            if (i .gt. 1) then
               do 3 k=1,kl
 3                amat(i,j) = amat(i,j) - amat(k,i)*amat(k,j)
            else if (amat(i,i) .le. 0.d0) then
               kxx = i
               return
            end if
            if (i.eq.j) then
               amat(i,i) = dsqrt(amat(i,i))
            else
               if (j.eq.i+1) ooa = 1.d0/amat(i,i)
               amat(i,j) = amat(i,j)*ooa
            end if
 7       continue
    8 continue
      do i=1,n
         do 12 j=i,n
            ooa = 1.d0/amat(j,j)
            if (i.ge.j) then
               t = 1.d0
            else
               kl = j - 1
               t = 0.d0
               do 11 k=i,kl
 11               t = t - amat(i,k)*amat(k,j)
            end if
 12         amat(i,j) = t*ooa
      enddo
      do i=1,n
         do j=i,n
            t = 0.d0
            do k=j,n
               t = t + amat(i,k)*amat(j,k)
            enddo
            amat(i,j) = t
            amat(j,i) = t
         enddo
      enddo
      return
      end


C ******************************************************************************


      subroutine ddnor(ystar,gauss)
      implicit real(8)(a-h,o-z)
c
c Copyright (c) James G. MacKinnon, 1993
c Routine to evaluate cumulative normal distribution
c Written originally in late 1970's
c Modified 1993 to avoid changing the argument
c
c This subroutine uses Cody's method to evaluate the cumulative
c normal distribution. It is probably accurate to 19 or 20
c significant digits. It was written in 1977, based on the Cody
c article referred to in the documentation for IMSL subroutine mdnor.
c
      real(8) p(6), q(5), a(9), b(8), c(5), d(4)
      data p(1)/-6.58749161529837803157d-04/,
     1     p(2)/-1.60837851487422766278d-02/,
     2     p(3)/-1.25781726111229246204d-01/,
     3     p(4)/-3.60344899949804439429d-01/,
     4     p(5)/-3.05326634961232344035d-01/,
     5     p(6)/-1.63153871373020978498d-02/
      data q(1)/2.33520497626869185443d-03/,
     1     q(2)/6.05183413124413191178d-02/,
     2     q(3)/5.27905102951428412248d-01/,
     3     q(4)/1.87295284992346047209d00/,
     4     q(5)/2.56852019228982242072d00/
      data a(1)/1.23033935479799725272d03/,
     1     a(2)/2.05107837782607146532d03/,
     2     a(3)/1.71204761263407058314d03/,
     3     a(4)/8.81952221241769090411d02/,
     4     a(5)/2.98635138197400131132d02/,
     5     a(6)/6.61191906371416294775d01/,
     6     a(7)/8.88314979438837594118d00/,
     7     a(8)/5.64188496988670089180d-01/,
     8     a(9)/2.15311535474403846343d-08/
      data b(1)/1.23033935480374942043d03/,
     1     b(2)/3.43936767414372163696d03/,
     2     b(3)/4.36261909014324715820d03/,
     3     b(4)/3.29079923573345962678d03/,
     4     b(5)/1.62138957456669018874d03/,
     5     b(6)/5.37181101862009857509d02/,
     6     b(7)/1.17693950891312499305d02/,
     7     b(8)/1.57449261107098347253d01/
      data c(1)/3.209377589138469472562d03/,
     1     c(2)/3.774852376853020208137d02/,
     2     c(3)/1.138641541510501556495d02/,
     3     c(4)/3.161123743870565596947d00/,
     4     c(5)/1.857777061846031526730d-01/
      data d(1)/2.844236833439170622273d03/,
     1     d(2)/1.282616526077372275645d03/,
     2     d(3)/2.440246379344441733056d02/,
     3     d(4)/2.360129095234412093499d01/
      data orpi/.5641895835477562869483d0/,
     1   root2/.70710678118654752440083d0/
c
      isw = 1
      y = ystar
      if (ystar.lt.-16.d0) y = -16.d0
      if (ystar.gt.16.d0) y = 16.d0
      x = -y*root2
      if(x.gt.0.d0) go to 1
      if(x.lt.0.d0) go to 2
      gauss = .5d0
      return
    2 continue
      x = - x
      isw = -1
    1 continue
      if(x.lt..477d0) go to 10
      if(x.le.4.d0) go to 20
c
c  evaluate erfc for x.gt.4.0
c
      x2 = x*x
      xm2 = 1.d0/x2
      xm4 = xm2*xm2
      xm6 = xm4*xm2
      xm8 = xm4*xm4
      xm10 = xm6*xm4
      top = p(1) + p(2)*xm2 + p(3)*xm4 + p(4)*xm6 + p(5)*xm8 + p(6)*xm10
      bot = q(1) + q(2)*xm2 + q(3)*xm4 + q(4)*xm6 + q(5)*xm8 + xm10
      crap = orpi + top/(bot*x2)
      erfc = dexp(-x2)*crap/x
c
      if(isw.eq.-1) erfc = 2.d0 - erfc
      gauss = erfc*.5d0
      return
   20 continue
c
c  evaluate erfc for .477.lt.x.le.4.0
c
      x2 = x*x
      x3 = x2*x
      x4 = x2*x2
      x5 = x3*x2
      x6 = x3*x3
      x7 = x3*x4
      x8 = x4*x4
      top = a(1) + a(2)*x + a(3)*x2 + a(4)*x3 + a(5)*x4 + a(6)*x5 +
     &  a(7)*x6 + a(8)*x7 + a(9)*x8
      bot = b(1) + b(2)*x + b(3)*x2 + b(4)*x3 + b(5)*x4 + b(6)*x5 +
     &  b(7)*x6 + b(8)*x7 + x8
      erfc = dexp(-x2)*top/bot
c
      if(isw.eq.-1) erfc = 2.d0 - erfc
      gauss = erfc*.5d0
      return
   10 continue
c
c  evaluate erf for x.lt..477
c
      x2 = x*x
      x4 = x2*x2
      x6 = x4*x2
      x8 = x4*x4
      top = c(1) + c(2)*x2 + c(3)*x4 + c(4)*x6 + c(5)*x8
      bot = d(1) + d(2)*x2 + d(3)*x4 + d(4)*x6 + x8
      erf = x*top/bot
c
      erf = erf*isw
      erfc = 1.d0 - erf
      gauss = erfc*.5d0
      return
      end


C ******************************************************************************


      subroutine innorz(prob,anorm)
      implicit real(8) (a-h,o-z)
c
c Copyright (c) James G. MacKinnon, 1995
c Inverse normal routine that adjusts crude result twice.
c It seems to be accurate to about 14 digits.
c Crude result is taken from Abramowitz & Stegun (1968)
c It should have abs. error < 4.5 * 10^-4
c
      data c0/2.515517d0/, d1/1.432788d0/, c1/0.802853d0/
      data c2/0.010328d0/, d3/0.001308d0/, d2/0.189269d0/
      data const/.398942280401432678d0/
      if (prob.lt.0.d0.or.prob.gt.1.d0) then
         call realpr('Attempt to find inverse normal of ', -1, prob, 1)
         call rexit('')
      end if
      pr = prob
      if (prob.gt.0.5d0) pr = 1.d0 - prob
      arg = 1/pr**2
      t = sqrt(log(arg))
      anorm = t - (c0 + c1*t + c2*t**2)/
     &  (1 + d1*t + d2*t**2 + d3*t**3)
c
c now correct crude result by direct method
c
      call ddnor(anorm,prob2)
      pr2 = 1.d0 - prob2
      arg = 1/pr2**2
      t = sqrt(log(arg))
      anorm2 = t - (c0 + c1*t + c2*t**2)/
     &  (1 + d1*t + d2*t**2 + d3*t**3)
      anorm = anorm + anorm - anorm2
      if (prob.lt.0.5d0) anorm = -anorm
c
c now correct better result, using Taylor series approximation
c
      call ddnor(anorm,prob2)
      error = prob2 - prob
      dens = const*dexp(-.5d0*anorm**2)
      anorm = anorm - error/dens
      return
      end

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file 


################################################################################
# FUNCTION:          MC KINNON'S PROBABILIY AND QUANTILES:
#  punitroot          Returns cumulative probability for unit root distributions
#  qunitroot          Returns quantiles for unit root distributions
#  unitrootTable      Returns McKinnon's unitroot finite sample test table
# FUNCTION:          INTERNAL UTILITY FUNCTIONS:
#  .strsplitUrcval    Implements string split function for S-Plus compatibility
#  .urcval            Implements unit root statists
#  .probsUrcval       Implements probability values
# FUNCTION:          INTERNAL DATA SETS:
#  .urc1 ... .urc12   Statistical values for unitroot data
################################################################################


test.asymptoticUnitroot = 
function()
{
    # n.sample = 0 | Inf
    # trend = c("c", "nc", "ct", "ctt"), 
    # statistic = c("t", "n")

    # Asymptotic quantiles
    tol = .Machine$double.eps^0.25
    X = c(0.05, 0.10, 0.50, 0.90, 0.95)
    
    Q = qunitroot(X, trend = "c",   statistic = "t")
    P = punitroot(Q,    trend = "c",   statistic = "t")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, trend = "nc",  statistic = "t")
    P = punitroot(Q,    trend = "nc",  statistic = "t")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, trend = "ct",  statistic = "t")
    P = punitroot(Q,    trend = "ct",  statistic = "t")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, trend = "ctt", statistic = "t")
    P = punitroot(Q,    trend = "ctt", statistic = "t")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol) 
    
    Q = qunitroot(X, trend = "c",   statistic = "n")
    P = punitroot(Q,    trend = "c",   statistic = "n")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, trend = "nc",  statistic = "n")
    P = punitroot(Q,    trend = "nc",  statistic = "n")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, trend = "ct",  statistic = "n")
    P = punitroot(Q,    trend = "ct",  statistic = "n")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, trend = "ctt", statistic = "n")
    P = punitroot(Q,    trend = "ctt", statistic = "n")   
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.finiteSizeUnitroot = 
function()
{    
    # Finite size quantiles - Sample Size = 100
    tol = .Machine$double.eps^0.25
    X = c(0.05, 0.10, 0.50, 0.90, 0.95)
    
    Q = qunitroot(X, 100, trend = "c",   statistic = "t")
    P = punitroot(Q, 100, trend = "c",   statistic = "t")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, 100, trend = "nc",  statistic = "t")
    P = punitroot(Q, 100, trend = "nc",  statistic = "t")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, 100, trend = "ct",  statistic = "t")
    P = punitroot(Q, 100, trend = "ct",  statistic = "t")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, 100, trend = "ctt", statistic = "t")
    P = punitroot(Q, 100, trend = "ctt", statistic = "t")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, 100, trend = "c",   statistic = "n")
    P = punitroot(Q, 100, trend = "c",   statistic = "n")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, 100, trend = "nc",  statistic = "n")
    P = punitroot(Q, 100, trend = "nc",  statistic = "n")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)
    
    Q = qunitroot(X, 100, trend = "ct",  statistic = "n")
    P = punitroot(Q, 100, trend = "ct",  statistic = "n")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol) 
    
    Q = qunitroot(X, 100, trend = "ctt", statistic = "n")
    P = punitroot(Q, 100, trend = "ctt", statistic = "n")
    print(cbind(Q, P))
    checkEqualsNumeric(target = X, current = P, tolerance = tol)

    # Return Value:
    return()    
}


################################################################################

\name{DickeyFullerPValues}
\alias{DickeyFullerPValues}

\alias{padf}
\alias{qadf}
\alias{adfTable}

\concept{unit root tests}
\concept{distribution of Dickey-Fuller test statistic}
\concept{distribution of augmented Dickey-Fuller test statistic}


\title{Dickey-Fuller p Values}

\description{
    
  A collection and description of functions to compute the distribution
  and quantile function for the ADF unit root test statistics.
    
}

\usage{
padf(q, N = Inf, trend = c("nc", "c", "ct"), statistic = c("t", "n")) 
qadf(p, N = Inf, trend = c("nc", "c", "ct"), statistic = c("t", "n"))

adfTable(trend = c("nc", "c", "ct"), statistic = c("t", "n"), 
    includeInf = TRUE)
}

\arguments{ 
  \item{q}{   
    vector of quantiles or test statistics. Missing values are allowed.
  }
  \item{p}{ 
    vector of probabilities. Missing values are allowed.
  }
  \item{N}{ 
    the number of observations in the sample from which the quantiles
    are to be computed.
  }
  \item{trend}{
    a character string describing the regression from which the
    quantiles are to be computed. Valid choices are: \code{"nc"} for a
    regression with no intercept (constant) nor time trend, \code{"c"}
    for a regression with an intercept (constant) but no time trend, and
    \code{"ct"} for a regression with an intercept (constant) and a time
    trend. The default is \code{"c"}.
  }
  \item{statistic}{ 
    a character string describing the type of test statistic.  Valid
    choices are \code{"t"} for t-statistic and \code{"n"} for normalized
    statistic, sometimes referred to as the rho-statistic. The default
    is \code{"t"}.
  }
  \item{includeInf}{
    a logical flag. Should the asymptotic value be included into the
    table?
  }
}

\details{
  \code{padf} computes cumulative probabilities for the ADF test.
  
  \code{qadf} computes quantiles for the ADF test.

  With sufficiently fine grid for the first argument, \code{padf} and
  \code{qadf} compute, respectively, cumulative distribution functions
  and quantile functions of ADF test statistics.
  
  \code{adfTable}  produces tables of p-values for ADF tests.
}

\value{ 
  for \code{padf} and \code{qadf}, a named numeric vector with attribute
  \code{"control"} holding \code{N},

  for \code{adfTable}, an object from class \code{"gridData"}, which is
  a list with the following components:

  \item{x}{the values of \code{N} (length of the time series) for which
    the statistics are provided,}
  \item{y}{quantiles for which the statistics are provided,}
  \item{Table}{ a matrix with one row for each \code{N} in \code{x} and
    one column for each quantile in \code{y}.}

  The \code{"gridData"} object contains also attribute \code{"control"}
  with information about the requested test.
}

\note{
  \code{padf} and \code{qadf} is based on the tables from A. Banerjee et
  al. (1993). Interpolation is used For value of \code{N} not in the
  tables. For small \code{N} (\code{N < 25}) the result is \code{NA}.
}

\author{
  Diethelm Wuertz for the Rmetrics \R-port.
}
    
\references{ 

Banerjee A., Dolado J.J., Galbraith J.W., Hendry D.F. (1993);
    \emph{Cointegration, Error Correction, and the Econometric 
        Analysis of Non-Stationary Data},
    Oxford University Press, Oxford. 
    
Dickey, D.A., Fuller, W.A. (1979);
    \emph{Distribution of the estimators for autoregressive time 
        series with a unit root}, 
    Journal of the American Statistical Association 74, 427--431. 
}

\examples{
padf(q = -2:2, N = 25)
qadf(p = (1:9)/10, N = 25)
adfTable()
}

\keyword{distribution}

\name{UnitrootTests}
\alias{UnitrootTests}

\alias{unitrootTest}
\alias{adfTest}

\concept{unit root tests}
\concept{Dickey-Fuller test}
\concept{augmented Dickey-Fuller test}
\concept{MacKinnon's unit root test}


\title{Unit root time series tests}

\description{
  Carry out augmented Dickey-Fuller tests for unit roots based on
  Banerjee's et al. tables and on J.G. McKinnons' numerical distribution
  functions.
}

\usage{
unitrootTest(x, lags = 1, type = c("nc", "c", "ct"), title = NULL, 
    description = NULL)
    
adfTest(x, lags = 1, type = c("nc", "c", "ct"), title = NULL, 
    description = NULL)
}

\arguments{
  \item{x}{
    a numeric vector or time series object.
  }  
  \item{lags}{
    the maximum number of lags used for error term correction.
  }
  \item{type}{    
    a character string describing the type of the unit root
    regression. Valid choices are \code{"nc"} for a regression with no
    intercept (constant) nor time trend, \code{"c"} for a regression
    with an intercept (constant) but no time trend, \code{"ct"} for a
    regression with an intercept (constant) and a time trend. The
    default is \code{"c"}.
  }
  \item{title}{
    a character string which allows for a project title.
  }
  \item{description}{
    a character string which allows for a brief description.
  }
}

\details{
    \code{adfTest()} computes test statistics and p-values along the
    implementation from Trapletti's augmented Dickey-Fuller test for
    unit roots. In contrast to Trapletti's function, three kind of test
    types can be selected.
    
    \code{unitrootTest()} computes test statistics and p-values using
    McKinnon's response surface approach.
}

\value{

    an object from S4 class \code{"fHTEST"} with the following slots:

    \item{@call}{
      the function call.      
    }
    \item{@data}{
      a data frame with the input data.
    }
    \item{@data.name}{
      a character string giving the name of the data frame.
    }
    \item{@test}{
      a list object which holds the output of the underlying test
      function.
    }
    \item{@title}{
      a character string with the name of the test.
    }
    \item{@description}{
      a character string with a brief description of the test.
    }
        
    The entries of the \code{@test} slot include the following components:

    \item{$statistic}{
      the value of the test statistic.
    }
    \item{$parameter}{
      the lag order.
    }
    \item{$p.value}{
      the p-value of the test.
    }
    \item{$method}{
      a character string indicating what type of test was performed.
    } 
    \item{$data.name}{
      a character string giving the name of the data.
    }
    \item{$alternative}{
      a character string describing the alternative hypothesis.
    }
    \item{$name}{
      the name of the underlying function, which may be wrapped.
    }
    \item{$output}{
      additional test results to be printed.
    }
}

\references{
Banerjee A., Dolado J.J., Galbraith J.W., Hendry D.F. (1993);
    \emph{Cointegration, Error Correction, and the Econometric 
        Analysis of Non-Stationary Data},
    Oxford University Press, Oxford. 
    
Dickey, D.A., Fuller, W.A. (1979);
    \emph{Distribution of the estimators for autoregressive time 
        series with a unit root}, 
    Journal of the American Statistical Association 74, 427--431. 
    
MacKinnon, J.G. (1996);
    \emph{Numerical distribution functions for unit root and 
        cointegration tests},
    Journal of Applied Econometrics 11, 601--618.
    
Said S.E., Dickey D.A. (1984);
    \emph{Testing for Unit Roots in Autoregressive-Moving Average 
        Models of Unknown Order},
    Biometrika 71, 599--607.
}

\author{
  Adrian Trapletti for the tests adapted from R's "tseries" package, \cr
  Diethelm Wuertz for the Rmetrics \R-port.
}

\examples{
## a time series which contains no unit-root:
x <- rnorm(1000)  
## a time series which contains a unit-root:
y <- cumsum(c(0, x))
   
adfTest(x)
adfTest(y)
   
unitrootTest(x)
unitrootTest(y)     
}

\keyword{htest}

\name{fUnitRoots-package}


\alias{fUnitRoots-package}
\alias{fUnitRoots}


\docType{package}


\title{Modelling Trends and Unit Roots}


\description{

    The Rmetrics "fUnitRoots" package is a collection of functions 
    to model trends and to analyze unit roots. 
    
}


% \details{
% 
%     \preformatted{
%         Package:    \tab fUnitRoots\cr
%         Type:       \tab Package\cr
%         Version:    \tab R 3.0.1\cr
%         Date:       \tab 2014\cr
%         License:    \tab GPL Version 2 or later\cr
%         Copyright:  \tab (c) 1999-2014 Rmetrics Association\cr
%         Repository: \tab R-FORGE\cr
%         URL:        \tab \url{https://www.rmetrics.org}
%     }
%     
% }


\section{1 Introduction}{

    The 'fUnitroots' provides four addons for analyzing trends and
    unit roots in financial time series: (i) functions for the density
    and probability of the augmented Dickey-Fuller Test, (ii) functions 
    for the density and probability of MacKinnon's unit root test 
    statistics, (iii) reimplementations for the ADF and MacKinnon
    Test, and (iv) an 'urca' Unit Root Test Interface for Pfaff's
    unit root test suite.
    
}


\section{2 Dickey-Fuller p Values}{

    The section provides functions to compute the distribution and 
    quantile functions for the ADF unit root test statistics. 
    
    \preformatted{
    padf            returns the cumulative probability for the ADF test
    qadf            returns the quantiles for the ADF test
    adfTable        tables p values for ADF test
    }
    
}


\section{3 Mc Kinnon p Values}{

    The section provides functions to compute the distribution and 
    quantile functions for MacKinnon's unit root test statistics. 
    
    \preformatted{
    punitroot       returns the cumulative probability
    qunitroot       returns the quantiles of the unit root test statistics
    unitrootTable   tables p values from MacKinnon's response surface
    }
    
}


\section{4 Unit Root Time Series Tests}{
    
    This section provides two functions for unit root testing of financial
    time series, the ADF tests based on Banerjee's et al. tables and the
    unit root tests based on J.G. McKinnons' tables:
    
    \preformatted{
    adfTest         augmented Dickey-Fuller test for unit roots
    unitrootTest    the same based on McKinnons's test statistics
    }

}


\section{5 "urca"" Unit Root Test Interface}{

    This is an interface to the unitroot tests suite implemented by 
    Bernhard Pfaff available through the \R package "\pkg{urca}" 
    
    \preformatted{
    urdfTest        Augmented Dickey-Fuller test for unit roots
    urersTest       Elliott--Rothenberg-Stock test for unit roots
    urkpssTest      KPSS unit root test for stationarity
    urppTest        Phillips-Perron test for unit roots
    urspTest        Schmidt-Phillips test for unit roots
    urzaTest        Zivot-Andrews test for unit roots
    }
  
}


\section{About Rmetrics}{

    The \code{fUnitroots} Rmetrics package is written for educational 
    support in teaching "Computational Finance and Financial Engineering" 
    and licensed under the GPL.
    
}


\keyword{package}

\name{UnitrootUrcaInterface}
\title{Unit Root Time Series Tests}

\alias{UnitrootUrcaInterface}

\alias{urdfTest}
\alias{urersTest}
\alias{urkpssTest}
\alias{urppTest}
\alias{urspTest}
\alias{urzaTest}

\description{
  
  A collection and description of functions for unit root testing.  
  This is an interface to the unitroot tests implemented by B. Pfaff
  available through the \R package "\pkg{urca}" which is required 
  here.

  Added functions based on the \pkg{urca} package include:

  \tabular{ll}{
    \code{urdfTest} \tab Augmented Dickey--Fuller test for unit roots, \cr
    \code{urersTest} \tab Elliott--Rothenberg--Stock test for unit roots, \cr
    \code{urkpssTest} \tab KPSS unit root test for stationarity, \cr
    \code{urppTest} \tab Phillips--Perron test for unit roots, \cr
    \code{urspTest} \tab Schmidt--Phillips test for unit roots, \cr
    \code{urzaTest} \tab Zivot--Andrews test for unit roots.
  }
  
}


\note{
  The functions \code{ur*Test()} fullfill the naming conventions
  of Rmetrics, return an S4 object named \code{fHTEST} as any other
  hypothesis test from Rmetrics, and allow for \code{timeSeries} objects
  as input.  These are the only differences to the original implementation
  of the functions.

  Fur further details we refer to the manual pages of the
  \pkg{urca} package which is required for all these.
  
}


\usage{
urdfTest(x, lags = 1, type = c("nc", "c", "ct"), doplot = TRUE)
urersTest(x, type = c("DF-GLS", "P-test"), model = c("constant", "trend"),
    lag.max = 4, doplot = TRUE)
urkpssTest(x, type = c("mu", "tau"), lags = c("short", "long", "nil"),
    use.lag = NULL, doplot = TRUE)
urppTest(x, type = c("Z-alpha", "Z-tau"), model = c("constant", "trend"),
    lags = c("short", "long"), use.lag = NULL, doplot = TRUE)
urspTest(x, type = c("tau", "rho"), pol.deg = c(1, 2, 3, 4),
    signif = c(0.01, 0.05, 0.1), doplot = TRUE)
urzaTest(x, model = c("intercept", "trend", "both"), lag, doplot = TRUE)
}

\arguments{
    %\item{description}{
    %    a character string which allows for a brief description.
    %    }
    \item{doplot}{
        [ur*Test] - \cr
        a logical flag, by default \code{TRUE}. Should a diagnostical
        plot be displayed?
        }
    \item{lag.max}{
        [urersTest] - \cr
        the maximum numbers of lags used for testing of a decent lag
        truncation for the \code{"P-test"}, BIC used, or the maximum
        number of lagged differences to be included in the test
        regression for \code{"DF-GLS"}.
        }
    \item{lag}{
        [urzaTest] - \cr
        the highest number of lagged endogenous differenced variables
        to be included in the test regression.
        }
    \item{lags}{
        [urkpssTest][urppTest] - \cr
        the maximum number of lags used for error term correction.
        }
    \item{model}{
        [urersTest] - \cr
        a character string dennoting the deterministic model used for
        detrending, either \code{"constant"}, the default, or
        \code{"trend"}. \cr
        [urppTest] - \cr
        a character string which determines the deterministic part in
        the test regression, either \code{"constant"}, the default, or
        \code{"trend"}. \cr
        [urzaTest] - \cr
        a character string specifying if the potential break occured
        in either the \code{"intercept"}, the linear \code{"trend"} or
        in \code{"both"}.
        }
    \item{pol.deg}{
        [urspTest] - \cr
        the polynomial degree in the test regression.
        }
    \item{signif}{
        [urspTest] - \cr
        the significance level for the critical value of the test
        statistic.
        }
    %\item{title}{
    %    a character string which allows for a project title.
    %    }
    \item{type}{
        [urkpssTest] - \cr
        a character string which denotes the type of deterministic part,
        either \code{"mu"}, the default, or \code{"tau"}.
        \cr
        [urppTest] - \cr
        a character string which specifies the test type, either
        \code{"Z-alpha"}, the default, or \code{"Z-tau"}.
        \cr
        [urspTest] - \cr
        a character string which specifies the test type, either
        \code{"tau"}, the default, or \code{"rho"}.
        }
    \item{use.lag}{
        [urkpssTest] - \cr
        a character string specifying the number of lags. Allowed
        arguments are \code{lags=c("short", "long", "nil")}, for more
        information see the details section.\cr
        [urppTest] - \cr
        Use of a different lag number, specified by the user.
        }
    \item{x}{
        a numeric vector or time series object.
        }
}


\details{
    \bold{Unit Root Tests from Berhard Pfaff's "\pkg{urca}" Package:}
    \cr

    \emph{Elliott--Rothenberg--Stock Test for Unit Roots:}
    \cr
    To improve the power of the unit root test, Elliot, Rothenberg and
    Stock proposed a local to unity detrending of the time series. ERS
    developed a feasible point optimal test, \code{"P-test"}, which
    takes serial correlation of the error term into account. The second
    test type is the \code{"DF-GLS"} test, which is an ADF-type test
    applied to the detrended data without intercept. Critical values
    for this test are taken from MacKinnon in case of \code{model="constant"}
    and else from Table 1 of Elliot, Rothenberg and Stock. \cr
    \code{[urca:ur.ers]} \cr

    \emph{KPSS Test for Unit Roots:}
    \cr
    Performs the KPSS unit root test, where the Null hypothesis is
    stationarity. The test types specify as deterministic component
    either a constant \code{"mu"} or a constant with linear trend
    \code{"tau"}. \code{lags="short"} sets the number of lags to
    \emph{root 4 of [4 times (n/100)}, whereas \code{lags="long"}
    sets the number of lags to \emph{root 4 of [12 times (n/100)]}.
    If \code{lags="nil"} is choosen, then no error correction is made.
    Furthermore, one can specify a different number of maximum lags
    by setting use.lag accordingly. \cr
    \code{[urca:ur.kpss]} \cr

    \emph{Phillips--Perron Test for Unit Roots:}
    \cr
    Performs the Phillips and Perron unit root test. Beside the
    Z statistics Z-alpha and Z-tau, the Z statistics for the
    deterministic part of the test regression are computed, too.
    For correction of the error term a Bartlett window is used. \cr
    \code{[urca:ur.pp]} \cr

    \emph{Schmidt--Phillips Test for Unit Roots:}
    \cr
    Performs the Schmidt and Phillips unit root test, where under
    the Null and Alternative Hypothesis the coefficients of the
    deterministic variables are included. Two test types are available:
    the \code{"rho-test"} and the \code{"tau-test"}. Both tests are
    extracted from the LM principle. \cr
    \code{[urca:ur.sp]} \cr

    \emph{Zivot--Andrews Test for Unit Roots:}
    \cr
    Performs the Zivot and Andrews unit root test, which allows a
    break at an unknown point in either the intercept, the linear
    trend or in both. This test is based upon the recursive estimation
    of a test regression. The test statistic is defined as the
    minimum t-statistic of the coeffcient of the lagged endogenous
    variable. \cr
    \code{[urca:ur.za]}

}


\value{

    All tests return an object of class \code{"fHTEST"} with the
    following slots:


    \item{@call}{
        the function call.
        }
    \item{@data}{
        a data frame with the input data.
        }
    \item{@data.name}{
        a character string giving the name of the data frame.
        }
    \item{@test}{
        a list object which holds the output of the underlying
        test function.
        }
    \item{@title}{
        a character string with the name of the test.
        }
    \item{@description}{
        a character string with a brief description of the
        test.
        }

    The entries of the \code{@test} slot include the following components:

    \item{$statistic}{
        the value of the test statistic.
        }
    \item{$parameter}{
        the lag order.
        }
    \item{$p.value}{
        the p-value of the test.
        }
    \item{$method}{
        a character string indicating what type of test was
        performed.
        }
    \item{$data.name}{
        a character string giving the name of the data.
        }
    \item{$alternative}{
        a character string describing the alternative
        hypothesis.
        }
    \item{$name}{
        the name of the underlying function, which may be wrapped.
        }
    \item{$output}{
        additional test results to be printed.
        }

}


\references{

Banerjee A., Dolado J.J., Galbraith J.W., Hendry D.F. (1993);
    \emph{Cointegration, Error Correction, and the Econometric
        Analysis of Non-Stationary Data},
    Oxford University Press, Oxford.

Dickey, D.A., Fuller, W.A. (1979);
    \emph{Distribution of the estimators for autoregressive time
        series with a unit root},
    Journal of the American Statistical Association 74, 427--431.

Kwiatkowski D., Phillips P.C.B, Schmidt P., Shin Y. (1992);
    \emph{Testing the Null Hypothesis of Stationarity against
    the Alternative of a Unit Root},
    Journal of Econometrics 54, 159--178.

Perron P. (1988);
    \emph{Trends and Random Walks in Macroeconomic Time Series},
    Journal of Economic Dynamics and Control 12, 297--332.

Phillips P.C.B., Perron P. (1988);
    \emph{Testing for a unit root in time series regression},
    Biometrika 75, 335--346.

Said S.E., Dickey D.A. (1984);
    \emph{Testing for Unit Roots in Autoregressive-Moving Average
        Models of Unknown Order},
    Biometrika 71, 599--607.

Schwert G.W. (1989);
    \emph{Tests for Unit Roots: A Monte Carlo Investigation},
    Journal of Business and Economic Statistics 2, 147--159.

}


\author{
    Bernhard Pfaff for the tests implemented in R's "\pkg{urca}" package,\cr
    Diethelm Wuertz for the Rmetrics \R-port.
}


\examples{
## Time Series
   # A time series which contains no unit-root:
   x <- rnorm(1000)
   # A time series which contains a unit-root:
   y <- cumsum(c(0, x))

## ERS Test:
 if(require("urca")) {
   urersTest(x)
   urersTest(y)
  }
}

\keyword{htest}

\name{MacKinnonPValues}

\alias{MacKinnonPValues}

\alias{punitroot}
\alias{qunitroot}
\alias{unitrootTable}

\concept{unit root tests}
\concept{distribution of MacKinnon's test statistic}


\title{MacKinnon's Unit Root p Values}

\description{
    A collection and description of functions 
    to compute the distribution and quantile 
    function for MacKinnon's unit root test statistics. 
}

\usage{
punitroot(q, N = Inf, trend = c("c", "nc", "ct", "ctt"), 
    statistic = c("t", "n"), na.rm = FALSE)
qunitroot(p, N = Inf, trend = c("c", "nc", "ct", "ctt"), 
    statistic = c("t", "n"), na.rm = FALSE)
    
unitrootTable(trend = c("c", "nc", "ct", "ctt"), statistic = c("t", "n")) 
}

\arguments{ 
  \item{q}{   
    vector of quantiles or test statistics. Missing values are allowed.
  }
  \item{p}{ 
    a numeric vector of probabilities. Missing values are allowed.
  }
  \item{N}{ 
    the number of observations in the sample from which the quantiles
    are to be computed.
  }
  \item{na.rm}{
    a logical value. If set to \code{TRUE}, missing values will be
    removed, otherwise not. The default is \code{FALSE}.
  }
  \item{statistic}{ 
    a character string describing the type of test statistic.  Valid
    choices are \code{"t"} for t-statistic, and \code{"n"} for
    normalized statistic, sometimes referred to as the
    rho-statistic. The default is \code{"t"}.
  }
  \item{trend}{
    a character string describing the regression from which the
    quantiles are to be computed. Valid choices are: \code{"nc"} for a
    regression with no intercept (constant) nor time trend, \code{"c"}
    for a regression with an intercept (constant) but no time trend, and
    \code{"ct"} for a regression with an intercept (constant) and a time
    trend. The default is \code{"c"}.
  }
}

\details{

  \code{punitroot} computes the cumulative probability of the asymptotic
  or finite sample distribution of the unit root test statistics.
    
  \code{qunitroot} computes the quantiles of the asymptotic or finite
  sample distribution of the unit root test statistics, given the
  probabilities.

  \code{unitrootTable} produces tables of p-values from MacKinnon's
  response surface.
}

\value{
  for \code{punitroot} and \code{qunitroot}, a numeric vector,

  for \code{unitrootTable}, a matrix with attribute \code{"control"}
  containing information about the type of test.
}

\note{
  The function \code{punitroot} and \code{qunitroot} use Fortran 
  routines and the response surface approach from J.G. MacKinnon (1988). 
  Many thanks to J.G. MacKinnon putting his code and tables under the 
  GPL license, which made this implementation possible.
}

\author{
  J.G. MacKinnon for the underlying Fortran routine and the tables, \cr
  Diethelm Wuertz for the Rmetrics \R-port.
}
    
\references{ 
Dickey, D.A., Fuller, W.A. (1979);
    \emph{Distribution of the estimators for autoregressive time 
        series with a unit root}, 
    Journal of the American Statistical Association 74, 427--431. 

MacKinnon, J.G. (1996);
    \emph{Numerical distribution functions for unit root and 
        cointegration tests},
    Journal of Applied Econometrics 11, 601--618.

Phillips, P.C.B., Perron, P. (1988);
    \emph{Testing for a unit root in time series regression}, 
    Biometrika 75, 335--346.
}

\examples{ 
## Asymptotic quantile of t-statistic
qunitroot(0.95, trend = "nc", statistic = "t")
## 1st argument a vector
qunitroot(c(0.90, 0.95), trend = "nc", statistic = "t")

## Finite sample quantile of n-statistic
qunitroot(0.95, N = 100, trend = "nc", statistic = "n") 


## Asymptotic cumulative probability of t-statistic
punitroot(1.2836, trend = "nc", statistic = "t")

## Finite sample cumulative probability of n-statistic
punitroot(1.2836, N = 100, trend = "nc", statistic = "n")

   
## Mac Kinnon's unitrootTable
unitrootTable(trend = "nc")
}

\keyword{distribution}
